#ifndef __ICSSACTION_H_INCLUDED__
#define __ICSSACTION_H_INCLUDED__

#include "csutil/scf.h"

struct iCStudioCS;

SCF_VERSION(icssAction, 0, 0, 1);
/// Interface for all actions that modify world data
struct icssAction : public iBase
{
  //// Initialize function for csi interface
  virtual bool Initialize(iCStudioCS *csi) = 0;
  //// Performs the action, false on error
  virtual bool Do() = 0;
  //// Undoes the action, false on error
  virtual bool Undo() = 0;
  //// Redoes the action, false on error
  virtual bool Redo() = 0;
  //// A short description of the action
  virtual const char *GetDescription() = 0;
};

#endif
