#ifndef __ICSSEDITMODEMANAGER_H_INCLUDED__
#define __ICSSEDITMODEMANAGER_H_INCLUDED__

#include "csutil/scf.h"

struct icssEditMode;


/*
* EditModeMangerCallBack
* Derive from this class and call icssEditModeManager::AddCallBack
* if you need to be notified if the EM changes
*/
struct icssEditModeManagerCB : public iBase
{
  virtual void OnEditModeChange (icssEditMode *nextactive) = 0;
};

SCF_VERSION(icssEditModeManagerCB, 0, 0, 1);

/*
* EditModeManager
* Keeps track of the current active Edit Mode
* Fires events if EditMode changes 
*/
struct icssEditModeManager : public iBase
{
  virtual void SetActiveEditMode (icssEditMode *newactive) = 0;
  virtual icssEditMode* GetActiveEditMode () = 0;

  virtual void AddCallBack (icssEditModeManagerCB *toadd) = 0;
  virtual void RemoveCallBack (icssEditModeManagerCB *torem) = 0;

  virtual csPtr<icssEditMode> GetEM (const char *name) = 0;
};

SCF_VERSION(icssEditModeManager, 0, 0, 1);

#endif
