#ifndef __ICSSACTIONMANAGER_H_INCLUDED__
#define __ICSSACTIONMANAGER_H_INCLUDED__

#include "csutil/scf.h"

struct icssAction;

SCF_VERSION(icssActionManager, 0, 0, 1);
/// icssActionManager manages all modifications to the world data
struct icssActionManager : public iBase
{
	/// Perform an action, add it to the undo queue
	/// and clear the redo stack
	virtual bool Perform(icssAction *toperform) = 0;
	/// Undo the last action and add that to the redo stack
	virtual bool Undo() = 0;
	/// pop action from redo stack and push it on undo queue
	virtual bool Redo() = 0;
	/// Clear the history of done stuff
	virtual void Clear() = 0;
	/// Get last action (needed to be able to bundle actions together (e.g. cssMoveAction)
	virtual icssAction *GetLastAction() = 0;
};

#endif

