#ifndef __ICSSCOMMANDMANAGER_H_INCLUDED__
#define __ICSSCOMMANDMANAGER_H_INCLUDED__

#include "csutil/scf.h"
/* icssCommand
* derive from this class to implement a callback for the console
*
*/

class csStringArray;

struct icssCommand : public iBase
{
  virtual bool OnCommand(csStringArray *args) = 0;
  virtual const char * GetCmdName() = 0;
  virtual const char * GetHelpLine() = 0;
  virtual const char * GetHelpDesc() = 0;
};
SCF_VERSION(icssCommand, 0, 0, 1);

/* icssCommandList
* used to manage multiple commands (to combine them in one dll
*/
struct icssCommandList : public iBase
{
  virtual size_t GetCount() = 0;
  virtual csPtr<icssCommand> Get(size_t idx) = 0;
};
SCF_VERSION(icssCommandList, 0, 0, 1);

/* icssCommandManager takes care of commands executed
in the console
*/
struct icssCommandManager : public iBase
{
  virtual void RegisterCommand(const char *cmd, icssCommand *cb) = 0;
  virtual void UnregisterCommand(const char *cmd) = 0;
  virtual bool Execute(const char *cmdline) = 0;
  virtual icssCommand *GetCommand(const char *cmd) = 0;
};
SCF_VERSION(icssCommandManager, 0, 0, 1);

#endif
