#ifndef __ICSSEDITMODE_H_INCLUDED__
#define __ICSSEDITMODE_H_INCLUDED__

#include "csutil/scf.h"

class wxEvent;
struct iCStudioCS;
struct icssView;
struct icssDrawer;
struct icssPlugin;

SCF_VERSION(icssEditMode, 0, 0, 1);

struct icssEditMode : public iBase
{
  

  /**
  @brief Gets the plugin class (scfParent)

  @return returns the plugin class
  */
  virtual icssPlugin *GetPlugin() = 0;

  /**
  @brief returns Description of the plugin to display in context-help etc.

  @return returns a const char array containing the string.
  */
  virtual const char *GetDescription() = 0;

  //// State changes
  virtual void OnActivate(icssEditMode *lastactive) = 0;
  virtual void OnDeactivate(icssEditMode *nextactive) = 0;
  
  /// Event catcher, use dynamic_cast to figure out type
  virtual bool OnEvent(wxEvent &event, icssView *view) = 0;
  
  /// Called when drawing is needed
  virtual void OnDraw (icssDrawer *d, icssView *v) = 0;
};


#endif

