#ifndef __ICSSSELECTOR_H_INCLUDED__
#define __ICSSSELECTOR_H_INCLUDED__

#include "csutil/scf.h"
#include "csgeom/box.h"
#include "csutil/refarr.h"

SCF_VERSION(icssSelector, 0, 0, 1);
/*
	icssSelector interface is responsible for selecting anything hitable via
	a hitbeam or inside-bounding-box routines. it also creates 
	icssThingPartSelection objects to support	thingpart selection. 
*/

struct icssSelector : public iBase
{
	// does a normal hitbeam test and returns the number of hit objects
  virtual int HitBeam(const csVector3 &begin, const csVector3 &end, float radius, csRefArray<iBase> &result) = 0;
	// does a bounding box test and fills the result array with the objects
	virtual int InBBox(csBox3 &bbox, csRefArray<iBase> &result) = 0;
};

#endif

