#ifndef __ICSSTHINGSELECTION_H_INCLUDED__
#define __ICSSTHINGSELECTION_H_INCLUDED__

#include "imesh/thing.h"
#include "csutil/scf.h"
#include "csutil/array.h"
#include "plugins/icssthingpart.h"



SCF_VERSION(icssThingSelection, 0, 0, 1);
/* Thing selection manages selection of vertices and faces in different things
therefore each item selected needs a reference to the thing it belongs to
*/

struct icssThingSelection : public iBase
{
	/// deselect all things
	virtual void Clear() = 0;
	/// Returns the number of selected meshes
	virtual size_t GetCount() = 0;
	/// Add a thingpartselection to the selection
	virtual size_t Add(icssThingPart *toadd) = 0;
	/// Remove a thingpartselection from the selection
	virtual void Remove(icssThingPart * toremove) = 0;
  /// check if a thing part is in the selection
  virtual bool Contains(icssThingPart *thingpart) = 0;
	/// get a selected thing mesh as selection wrapper
	virtual icssThingPart * Get(size_t idx) = 0;

};

#endif
