#ifndef __ICSSVIEW_H_INCLUDED__
#define __ICSSVIEW_H_INCLUDED__

#include "csutil/scf.h"
#include "csgeom/vector3.h"
#include "csgeom/segment.h"
#include "csgeom/vector2.h"

typedef char wxChar;

class wxWindow;

SCF_VERSION(icssView, 0, 0, 1);

struct icssView : public iBase
{
  virtual void GetMapPosfromMouseCoords(int x, int y, csVector3 &omappos) = 0;
  
  virtual void MapToView(const csVector3 &mappos, csVector2 &viewpos) = 0;
  
  /*  calcuates the new position of a point, given the new 2d coordinates
  pos: the old position of the point
  newpos2d: 2d coordinates of the now position
  newpos: new position of the point
  y_direction: for perspective view: move in y direction instead of x/z
  */
  virtual bool MovePoint(const csVector3 &pos, const csVector2 &newpos2d, 
    csVector3 &newpos3d, bool y_direction = false) = 0;
    
  virtual void CreateBeam(int x, int y, csSegment3 &beam) = 0;
  
  /// Redraw the window
  virtual void Redraw() = 0;
  /// returns the first object it grabs at mouse position
  virtual csSegment3 GetSegmentAt(int x, int y) = 0;
  /// Get a handle to the WX Window 
  virtual wxWindow * GetWxWindow() = 0;
};


#endif
