#ifndef __ACTIONMGR_H_INCLUDED__
#define __ACTIONMGR_H_INCLUDED__

#include "plugins/icssplugin.h"
#include "action/icssaction.h"
#include "plugins/icssactionmanager.h"
#include "app/icsstudio.h"
#include "csutil/ref.h"
#include "csutil/refarr.h"


class cssActionManagerPlugin : public icssPlugin
{
	iCStudioCS* m_csi;
public:
	cssActionManagerPlugin(iBase *parent);
	virtual ~cssActionManagerPlugin();

	//// icssPlugin interface
	virtual bool Initialize(iCStudioCS *csi);
	virtual const char *GetName();
	
	//// icssActionManager interface
	csRefArray<icssAction> m_done;
	csRefArray<icssAction> m_undone;

	bool Perform(icssAction *toperform);
	bool Undo();
	bool Redo();
	void Clear();
	icssAction * GetLastAction();
	class cssActionManager : public icssActionManager
	{
		SCF_DECLARE_EMBEDDED_IBASE(cssActionManagerPlugin);
		virtual bool Perform(icssAction *toperform)
		{ return scfParent->Perform(toperform); };
		virtual bool Undo()
		{ return scfParent->Undo(); };
		virtual bool Redo()
		{ return scfParent->Redo(); };
		virtual void Clear()
		{ scfParent->Clear(); };
		virtual icssAction *GetLastAction()
		{ return scfParent->GetLastAction(); };
	} scficssActionManager;
	friend class cssActionManager;
	


	SCF_DECLARE_IBASE;

};


#endif
