#include "cst-config.h"
#include "wx/wxprec.h"

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "cssysdef.h"

#include <wx/textctrl.h>
#include <wx/button.h>

#include "consolewnd.h"
#include "console.h"


enum ctrllist
{
  EXECUTE_BUTTON = wxID_HIGHEST + 1,
  CONSOLE_TEXT,
  COMMAND_TEXT
};


BEGIN_EVENT_TABLE (cssConsoleWindow, wxPanel)
  EVT_BUTTON( EXECUTE_BUTTON, cssConsoleWindow::OnExecute)
END_EVENT_TABLE()

cssConsoleWindow :: cssConsoleWindow
     ( 
       cssConsolePlugin *cmdmgr,
       wxWindow *parent,
       int posx, int posy,
       int sizex, int sizey
     ) : 
     wxPanel(parent, -1, wxPoint(posx, posy), wxSize(sizex, sizey), wxCLIP_CHILDREN)
{
  this->cmdmgr = cmdmgr;
  cmdmgr->consolewnd = this;

  commandText = new wxTextCtrl( this,
    COMMAND_TEXT,
    wxT(""),
    wxPoint(10,318),
    wxSize(430,21));

  executeButton = new wxButton( this,
    EXECUTE_BUTTON,
    wxT(""),
    wxPoint(448,318),
    wxSize(80,21));

  executeButton->SetLabel( wxT( "Execute" ) );

  consoleText = new wxTextCtrl( this,
    CONSOLE_TEXT,
    wxT(""),
    wxPoint(5,4),
    wxSize(524,311),
    wxVSCROLL|wxHSCROLL|wxTE_READONLY|wxTE_MULTILINE);


  wxBoxSizer *lowsizer = new wxBoxSizer ( wxHORIZONTAL );
  lowsizer->Add(commandText, 1, wxEXPAND | wxLEFT | wxRIGHT, 3);
  lowsizer->Add(executeButton, 0, wxALL , 3);

  wxBoxSizer *topsizer = new wxBoxSizer( wxVERTICAL );

  topsizer->Add(
    consoleText,
    1,            // make vertically stretchable
    wxEXPAND |    // make horizontally stretchable
    wxALL,        //   and make border all around
    3 );         // set border width to 10

  topsizer->Add(lowsizer,
    0,
    wxEXPAND,
    3);

  SetSizer( topsizer );      // use the sizer for layout
 
}

cssConsoleWindow::~cssConsoleWindow()
{
  cmdmgr->consolewnd = 0;
}

void cssConsoleWindow :: OnExecute(wxCommandEvent & event)
{
  wxString cmd = commandText->GetValue();
  if(!cmd.IsEmpty())
    cmdmgr->Execute(cmd.GetData());
}

void cssConsoleWindow::Print(const char *text)
{
  consoleText->AppendText(text);
}

void cssConsoleWindow::Clear()
{
  consoleText->Clear();
}


