/*
    Copyright (C) 2003 by Philipp Aumayr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __CONSOLEWND_H_INCLUDED__
#define __CONSOLEWND_H_INCLUDED__

#include "wx/panel.h"

#include "csutil/scf.h"
#include "csutil/weakref.h"

class cssConsolePlugin;

struct icssCommandManager;

class wxTextCtrl;
class wxButton;

class cssConsoleWindow : public wxPanel
{
  cssConsolePlugin* cmdmgr;
public:

  cssConsoleWindow
    (  cssConsolePlugin *cmdmgr,
       wxWindow *parent,
       int posx, int posy,
       int sizex, int sizey
     );

  virtual ~cssConsoleWindow();

  void Print(const char *text);
  void Clear();
private:
  wxTextCtrl* consoleText;
  wxTextCtrl* commandText;
  wxButton* executeButton;

  void OnExecute(wxCommandEvent& event);
  void OnClose(wxCloseEvent& event);

  
  DECLARE_EVENT_TABLE()

};

#endif
