/*
    Copyright (C) 2003 by Philipp Aumayr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __ABOUT_H_INCLUDED__
#define __ABOUT_H_INCLUDED__

#include "iutil/objreg.h"
#include "plugins/icsscommandmanager.h"

#include "csutil/stringarray.h"

class cssAboutCommand : public icssCommand
{
  iCStudioCS* m_csi;
public:
  cssAboutCommand(iCStudioCS *csi) 
  { 
    SCF_CONSTRUCT_IBASE(0);
    m_csi = csi; 
  };
  virtual ~cssAboutCommand() 
  {
    SCF_DESTRUCT_IBASE ();
  };

  SCF_DECLARE_IBASE;

  virtual const char * GetCmdName()
  {
    return "about";
  };

  virtual const char * GetHelpLine()
  {
    return "no params, use \"about<enter>\", displays info about CStudio\n";
  };

  virtual const char * GetHelpDesc()
  {
    return "no big description about about available :-)\n";
  };

  virtual bool OnCommand (csStringArray *args)
  {
    m_csi->Print("Crystal Studio - a World Editor for Crystal Space\n");
    return true; // success
  };
};

SCF_IMPLEMENT_IBASE (cssAboutCommand)
SCF_IMPLEMENTS_INTERFACE (icssCommand)
SCF_IMPLEMENT_IBASE_END

#endif

