#ifndef __CREATELIGHTACTION_H_INCLUDED__
#define __CREATELIGHTACTION_H_INCLUDED__

#include "action/icsscreatelight.h"

#include "csutil/csstring.h"
#include "csgeom/vector3.h"
#include "csutil/cscolor.h"
#include "iengine/light.h"

struct iEngine;
struct iCStudioCS;

class cssCreateLightAction : public icssAction
{
	csString name;
	csVector3 pos;
  float radius;
	csColor color;

	iCStudioCS* m_csi;
	csRef<iLight> light;

public:

	cssCreateLightAction(iBase *parent);
	virtual ~cssCreateLightAction();
	SCF_DECLARE_IBASE;
	//// icssAction interface
	virtual bool Initialize(iCStudioCS *csi);
	virtual bool Do();
	virtual bool Undo();
	virtual bool Redo();

	//// icssCreateLightAction interface
	void SetParams(const char* name, const csVector3& pos,
  	float radius, const csColor& color);
	void SetName(const char *name);
	void SetPosition(const csVector3 & pos);
	void SetRadius(float radius);
	void SetColor(const csColor &color);
	class cssCreateLightActionI : public icssCreateLightAction
	{
		SCF_DECLARE_EMBEDDED_IBASE(cssCreateLightAction);
		virtual void SetParams(const char* name, const csVector3& pos,
  	float radius, const csColor& color)
		{ scfParent->SetParams(name, pos, radius, color); };
    virtual void SetName(const char *name)
		{ scfParent->SetName(name); };
		virtual void SetPosition(const csVector3 & pos)
		{ scfParent->SetPosition(pos); };
    virtual void SetRadius(float radius)
		{ scfParent->SetRadius(radius); };
		virtual void SetColor(const csColor &color)
		{ scfParent->SetColor(color); };
	} scficssCreateLightAction;
	friend class cssCreateLightActionI;


};


#endif

