/*
    Copyright (C) 2003 by Philipp Aumayr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __STDCMDS_H_INCLUDED__
#define __STDCMDS_H_INCLUDED__

#include "csutil/refarr.h"

#include "plugins/icssplugin.h"
#include "plugins/icsscommandmanager.h"


struct iCStudioCS;

class cssStdCommandsPlugin : public icssPlugin
{
  csRefArray<icssCommand> m_cmds;
  iCStudioCS* m_csi;
public:
  cssStdCommandsPlugin(iBase *parent);
  virtual ~cssStdCommandsPlugin();

  SCF_DECLARE_IBASE;

  /// icssPlugin implementation
  virtual bool Initialize(iCStudioCS *csi);
  virtual const char *GetName()
  { return "cstudio.cmd.stdcmds"; };

  size_t GetCount();
  csPtr<icssCommand> Get(size_t idx);

  /// cssCommandList interface
  class cssCommandList : public icssCommandList
  {
  public:
    SCF_DECLARE_EMBEDDED_IBASE(cssStdCommandsPlugin);
    virtual size_t GetCount()
    { return scfParent->GetCount(); };
    virtual csPtr<icssCommand> Get(size_t idx)
    { return scfParent->Get(idx); };
  } scficssCommandList;
  friend class cssCommandList;

};

#endif
