#include "cssysdef.h"

#include "iengine/engine.h"
#include "iengine/mesh.h"
#include "iengine/material.h"
#include "iengine/movable.h"
#include "iutil/objreg.h"
#include "imesh/thing.h"
#include "imesh/object.h"
#include "iengine/sector.h"
#include "imap/loader.h"

#include "app/icsstudio.h"

#include "fromfactaction.h"

SCF_IMPLEMENT_IBASE(cssFromFactAction)
SCF_IMPLEMENTS_INTERFACE(icssAction)
SCF_IMPLEMENTS_EMBEDDED_INTERFACE(icssFromFactAction)
SCF_IMPLEMENT_IBASE_END

SCF_IMPLEMENT_EMBEDDED_IBASE(cssFromFactAction::ecssFromFactAction)
SCF_IMPLEMENTS_INTERFACE(icssFromFactAction)
SCF_IMPLEMENT_EMBEDDED_IBASE_END

SCF_IMPLEMENT_FACTORY(cssFromFactAction);

cssFromFactAction::cssFromFactAction(iBase *parent)
{
  SCF_CONSTRUCT_IBASE(parent);
  SCF_CONSTRUCT_EMBEDDED_IBASE(scficssFromFactAction);
}

cssFromFactAction::~cssFromFactAction()
{
  SCF_DESTRUCT_EMBEDDED_IBASE(scficssFromFactAction);
  SCF_DESTRUCT_IBASE();
}

bool cssFromFactAction::Initialize(iCStudioCS *csi)
{
  m_csi = csi;
  return true;
}

bool cssFromFactAction::Do()
{
  if(!m_sector)
    return false;
 
  csRef<iEngine> e = 
    	CS_QUERY_REGISTRY(m_csi->getObjectRegistry(), iEngine);

  m_meshwrap = e->CreateMeshWrapper(m_meshfactorywrapper, m_name.GetData(), m_sector, m_position);

  if(!m_meshwrap)
    return false;

  return true;
}

bool cssFromFactAction::Undo()
{
  csRef<iEngine> e =
        CS_QUERY_REGISTRY (m_csi->getObjectRegistry(), iEngine);

  e->RemoveObject(m_meshwrap);
  m_meshwrap = 0; // remove object completly
  
  return true;
}

bool cssFromFactAction::Redo()
{
  return Do();
}
  
void cssFromFactAction::SetPosition(csVector3 &pos)
{
  m_position = pos;
}

void cssFromFactAction::SetSector(iSector *s)
{
  m_sector = s;
}

void cssFromFactAction::SetFactory(iMeshFactoryWrapper *mfw)
{
  m_meshfactorywrapper = mfw;
}

void cssFromFactAction::SetName(const char *name)
{
  m_name = name;
}
