#ifndef __FROMFACTACTION_H_INCLUDED__
#define __FROMFACTACTION_H_INCLUDED__

#include "action/icssaction.h"
#include "action/create/icssfromfactaction.h"

#include "csgeom/vector3.h"
#include "csutil/csstring.h"


class cssFromFactAction : public icssAction
{
  csRef<iCStudioCS> m_csi;
  csRef<iMeshWrapper> m_meshwrap;

  csVector3 m_position;
  csRef<iSector> m_sector;
  csRef<iMeshFactoryWrapper> m_meshfactorywrapper;
  csString m_name;
  

public:
  SCF_DECLARE_IBASE;
  cssFromFactAction(iBase *parent);
  virtual ~cssFromFactAction();

  virtual bool Initialize(iCStudioCS *csi);
  virtual bool Do();
  virtual bool Undo();
  virtual bool Redo();
  virtual const char *GetDescription()
  { return "Create Mesh From Factory"; }
  
  void SetPosition(csVector3 &pos);
  void SetSector(iSector *s);
  void SetFactory(iMeshFactoryWrapper *mfw);
  void SetName(const char *name);

  class ecssFromFactAction : public icssFromFactAction
  {
    SCF_DECLARE_EMBEDDED_IBASE(cssFromFactAction);
    virtual void SetPosition(csVector3 &pos) 
    { scfParent->SetPosition(pos); };
    virtual void SetSector(iSector *s)
    { scfParent->SetSector(s); };
    virtual void SetFactory(iMeshFactoryWrapper *mfw)
    { scfParent->SetFactory(mfw); };
    virtual void SetName(const char *name)
    { scfParent->SetName(name); };
  } scficssFromFactAction;
  friend class ecssFromFactAction;

};

#endif
