#ifndef __FROMFACTDLG_H_INCLUDED__
#define __FROMFACTDLG_H_INCLUDED__

#include "wx/dialog.h"
#include "wx/listctrl.h"
#include "wx/panel.h"
#include "wx/textctrl.h"

struct iCStudioCS;
struct iMeshFactoryWrapper;

class cssFromFactDlg : public wxDialog
{
  iCStudioCS * m_csi;
public:
 cssFromFactDlg(iCStudioCS *csi, wxWindow* parent, wxWindowID id, 
                  const wxString& title, const wxPoint& pos = wxDefaultPosition, 
                  const wxSize& size = wxDefaultSize, long style = wxDEFAULT_DIALOG_STYLE, 
                  const wxString& name = "dialogBox");
  virtual ~cssFromFactDlg();

  const char *GetName();
  iMeshFactoryWrapper *GetFactoryWrapper();
  void FillDialog();
  void InsertFactoryWrapper(int idx, iMeshFactoryWrapper *mfw);
  const char * DetermineFactoryType(iMeshFactoryWrapper *mfw);

  void OnFactListItemSelected(wxListEvent &e);
  
  wxListView *m_factlistctrl;
  wxPanel    *m_previewpanectrl;
  wxTextCtrl *m_namectrl;

  // don't care about ref counting in a dialog
  iMeshFactoryWrapper * m_meshfactorywrapper;

  DECLARE_EVENT_TABLE();
};


#endif
