#include "cssysdef.h"

#include "iengine/engine.h"
#include "iengine/sector.h"
#include "csutil/objreg.h"

#include "action/create/icsscreatesectoraction.h"
#include "app/icsstudio.h"


#include "createsectoraction.h"


SCF_IMPLEMENT_IBASE(cssCreateSectorAction)
SCF_IMPLEMENTS_INTERFACE(icssAction)
SCF_IMPLEMENTS_EMBEDDED_INTERFACE(icssCreateSectorAction)
SCF_IMPLEMENT_IBASE_END

SCF_IMPLEMENT_EMBEDDED_IBASE(cssCreateSectorAction::ecssCreateSectorAction)
SCF_IMPLEMENTS_INTERFACE(icssCreateSectorAction)
SCF_IMPLEMENT_EMBEDDED_IBASE_END

SCF_IMPLEMENT_FACTORY(cssCreateSectorAction);

cssCreateSectorAction::cssCreateSectorAction(iBase *parent)
{
  SCF_CONSTRUCT_IBASE(parent);
  SCF_CONSTRUCT_EMBEDDED_IBASE(scficssCreateSectorAction);

}

cssCreateSectorAction::~cssCreateSectorAction()
{
  SCF_DESTRUCT_EMBEDDED_IBASE(scficssCreateSectorAction);
  SCF_DESTRUCT_IBASE();
}

bool cssCreateSectorAction::Initialize(iCStudioCS *csi)
{
  m_csi = csi;
  return true;
}

bool cssCreateSectorAction::Do()
{
  csRef<iEngine> e = 
       CS_QUERY_REGISTRY(m_csi->getObjectRegistry(), iEngine);

  m_sec = e->CreateSector(m_name);
  if(!m_sec)
    return false;

  m_csi->SetActiveSector(m_sec);
  
  return true;
}

bool cssCreateSectorAction::Undo()
{
  csRef<iEngine> e =
	CS_QUERY_REGISTRY(m_csi->getObjectRegistry(), iEngine);
  
  e->RemoveObject(m_sec);
  m_csi->SetActiveSector(e->GetSectors()->Get(0));
  return true;
}

bool cssCreateSectorAction::Redo()
{
  return Do();
}


void cssCreateSectorAction::SetName(const char *name)
{
  strcpy(m_name, name);
}


