#ifndef __CREATESECTORACTION_H_INCLUDED__
#define __CREATESECTORACTION_H_INCLUDED__

#include "action/icssaction.h"
#include "action/create/icsscreatesectoraction.h"

struct iSector;
struct iCStudioCS;

class cssCreateSectorAction : public icssAction
{
  csRef<iSector> m_sec;
  csRef<iCStudioCS> m_csi;
  char m_name[128];
public:

  SCF_DECLARE_IBASE;
 
  cssCreateSectorAction(iBase *parent);
  virtual ~cssCreateSectorAction();

  virtual bool Initialize(iCStudioCS *csi);
  virtual bool Do(); 
  virtual bool Undo();
  virtual bool Redo();
  virtual const char *GetDescription()
  { return "Create Sector"; }
  

  void SetName(const char *name);
  class ecssCreateSectorAction : public icssCreateSectorAction
  {
    SCF_DECLARE_EMBEDDED_IBASE(cssCreateSectorAction);
    virtual void SetName(const char *name)
    { scfParent->SetName(name); };
  } scficssCreateSectorAction;
  friend class ecssCreateSectorAction;

};


#endif

