#ifndef __THINGBOXACTION_H_INCLUDED__
#define __THINGBOXACTION_H_INCLUDED__

#include "action/icssaction.h"
#include "action/create/icssthingboxaction.h"

#include "csgeom/vector3.h"

struct iMeshWrapper;
struct iMeshFactoryWrapper;
struct iMaterialWrapper;

class cssThingBoxAction : public icssAction
{
  csRef<iCStudioCS> m_csi;
  csRef<iMeshWrapper> m_meshwrap;

  csVector3 m_bb_min, m_bb_max;
  csRef<iMaterialWrapper> m_matwrap;
  csRef<iSector> m_sector;

public:
  SCF_DECLARE_IBASE;
  cssThingBoxAction(iBase *parent);
  virtual ~cssThingBoxAction();

  virtual bool Initialize(iCStudioCS *csi);
  virtual bool Do();
  virtual bool Undo();
  virtual bool Redo();
  virtual const char *GetDescription()
  { return "Create Thing Box"; }
  
  void SetBBox(csVector3 &min, csVector3 &max);
  void SetMaterial(iMaterialWrapper *mat);
  void SetSector(iSector *s);

  class ecssThingBoxAction : public icssThingBoxAction
  {
    SCF_DECLARE_EMBEDDED_IBASE(cssThingBoxAction);
    virtual void SetBBox(csVector3 &bb_min, csVector3 &bb_max) 
    { scfParent->SetBBox(bb_min, bb_max); };
    virtual void SetMaterial(iMaterialWrapper *mat)
    { scfParent->SetMaterial(mat); };
    virtual void SetSector(iSector *s)
    { scfParent->SetSector(s); };
  } scficssThingBoxAction;
  friend class ecssThingBoxAction;

};

#endif

