/*
    Copyright (C) 2005 by Jan Lepper

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __CSS_CSPTREE_H__
#define __CSS_CSPTREE_H__

#include "csutil/array.h"
#include "csgeom/plane3.h"

#include "csgplugin.h"
#include "csgmesh.h"


class cssBspTree
{
  cssBspTree *front, *back;
  csPlane3 pl;

public:

  cssBspTree();
  ~cssBspTree();

  void Build(const cssPolyArray& polys);
  void Build(const cssCsgMesh& mesh);
  void Clear();
  bool PointInside(const csVector3& pt);
  float Classify(const csVector3& pt);

};



#endif
