/*
    Copyright (C) 2005 by Jan Lepper

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __CSGACTION_H_INCLUDED__
#define __CSGACTION_H_INCLUDED__

#include "csgplugin.h"
#include "action/icssaction.h"
#include "bsptree.h"


struct iMeshWrapper;

class cssCsgAction : public icssAction
{
	iCStudioCS* csi;

        csRef<iSector> sector;
	
        //csRefArray<iMeshWrapper> source_meshes;
	csRef<iMeshWrapper> mesh1;
	csRef<iMeshWrapper> mesh2;

	csRef<iMeshWrapper> output_mesh;

	int csg_operation;
	int output_mesh_type;
	bool remove_source_meshes;

 
    void ProcessMesh(
                cssCsgMesh& mesh,
                cssCsgMesh& clipper,
                cssCsgMesh& new_mesh,
                cssBspTree& bsp1,
                cssBspTree& bsp2,
                bool mesh_to_process);

 
    void CsgOperation(cssCsgMesh& mesh1, cssCsgMesh& mesh2, cssCsgMesh& new_mesh);
 
public:

	SCF_DECLARE_IBASE;

	cssCsgAction(iBase *parent);
	virtual ~cssCsgAction ();

	void SetSourceMeshes(iMeshWrapper* mesh1, iMeshWrapper* mesh2);
	void SetOperation(int operation);

	//// icssAction interface
	virtual bool Initialize(iCStudioCS *csi);
	virtual bool Do();
	virtual bool Undo();
	virtual bool Redo();
	virtual const char *GetDescription()
	{ return "CSG Operation"; }
};

#endif
