/*
    Copyright (C) 2005 by Jan Lepper

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __CSS_CSG_CMD_H__
#define __CSS_CSG_CMD_H__


#include "csutil/stringarray.h"
#include "app/icsstudio.h"
#include "plugins/icsscommandmanager.h"


struct icssActionManager;
struct iSector;

class cssCsgCommand : public icssCommand
{
  iCStudioCS* csi;
  csRef<icssActionManager> actionmgr;

  //bool CreateTestMeshes();
  //csPtr<iMeshWrapper> CreateMesh(csBox3, bool, const char*, iSector*, iEngine*);

  //csRef<iMeshWrapper> mesh1, mesh2;
  
  void PrintUsage()
  {
     csi->Print("usage: csg [add | subtract | intersect]\n");
  }
  
public:

  SCF_DECLARE_IBASE;

  cssCsgCommand(iCStudioCS *csi);
  virtual ~cssCsgCommand();
  
  virtual const char * GetCmdName()
  {
    return "csg";
  };

  virtual const char * GetHelpLine()
  {
    return "do a csg operation";
  };

  virtual const char * GetHelpDesc()
  {
    return "csg [add|subtract]";
  };

  virtual bool OnCommand (csStringArray *args);
  
};

#endif
