/*
    Copyright (C) 2004 by Jan Lepper

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __CSS_CSG_MESH_H__
#define __CSS_CSG_MESH_H__

#include "csutil/csstring.h"

#include "iengine/material.h"


struct iMeshWrapper;
struct iThingFactoryState;
struct iSector;

enum
{
  CSS_MESHTYPE_THING,
  CSS_MESHTYPE_GENERAL
};


struct cssCsgPolygon
{
  csPoly3D poly;
  csRef<iMaterialWrapper> material;

  /// TODO: texture mapping

  cssCsgPolygon(const cssCsgPolygon& source)
  {
     poly = source.poly;
     material = source.material;
  }
  cssCsgPolygon(const csPoly3D& poly, iMaterialWrapper* material)
  {
     this->poly = poly;
     this->material = material;
  }
  
};


class cssCsgMesh
{

  //friend class cssCsgClipper;

  csString name;

  csRef<iSector> sector;
  csRef<iEngine> engine;

  int type;

  csPtr<iMeshWrapper> BuildThing();
  csPtr<iMeshWrapper> BuildGenMesh();

public:

  csArray<cssCsgPolygon> polys;

  bool ImportMesh(iMeshWrapper* mesh);
  bool ImportThingFactory(iThingFactoryState* thing_fact);

  cssCsgMesh(iEngine* engine, iSector* sector, const char* name, int type);
  cssCsgMesh();
  ~cssCsgMesh();

  //void CopyPolygons(cssPolyArray& output) const;

  csPtr<iMeshWrapper> Build();
};

#endif
