/*
    Copyright (C) 2004 by Jan Lepper

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "cssysdef.h"

#include "csutil/objreg.h"
#include "iengine/engine.h"

#include "app/icsstudio.h"
#include "csgcmd.h"
#include "csgplugin.h"

CS_IMPLEMENT_PLUGIN;

SCF_IMPLEMENT_FACTORY(cssCsgPlugin);

SCF_IMPLEMENT_IBASE(cssCsgPlugin)
SCF_IMPLEMENTS_INTERFACE(icssPlugin)
SCF_IMPLEMENT_IBASE_END



cssCsgPlugin::cssCsgPlugin(iBase* p)
{ 
  SCF_CONSTRUCT_IBASE(p);
}


cssCsgPlugin::~cssCsgPlugin()
{
  SCF_DESTRUCT_IBASE();
}


bool cssCsgPlugin::Initialize(iCStudioCS *csi)
{
 csRef<icssPlugin> console = csi->GetPlugin("cstudio.cmd.console");
  if(!console)
    return false;
  
  csRef<icssCommandManager> cm = SCF_QUERY_INTERFACE(console, icssCommandManager);
  if(!cm)
    return false;

  csRef<icssCommand> cmd;

  cmd = csPtr<icssCommand> (new cssCsgCommand(csi));
  cm->RegisterCommand("csg", cmd);

  return true;
}
