/*
    Copyright (C) 2004 by Jan Lepper

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __CSS_CSG_H__
#define __CSS_CSG_H__

#include "csutil/array.h"
#include "csutil/parray.h"
#include "csgeom/poly3d.h"

#include "plugins/icssplugin.h"
#include "plugins/icsscommandmanager.h"

struct iEngine;
class cssCsgMesh;

typedef csArray<csPoly3D> cssPolyArray;

enum
{
  CSS_CSG_ADD = 0,
  CSS_CSG_SUBTRACT,
  CSS_CSG_INTERSECT
};


class cssCsgPlugin : public icssPlugin
{
public:

  SCF_DECLARE_IBASE;

  cssCsgPlugin(iBase* p);

  virtual ~cssCsgPlugin();
    

  /// icssPlugin functions
  virtual bool Initialize(iCStudioCS *csi);
	virtual const char *GetName()
	{ return "cstudio.plugin.csg"; };

};

#endif
