/*
    Copyright (C) 2003 by Philipp Aumayr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __CSS_EDITMODEMANAGER_H_INCLUDED__
#define __CSS_EDITMODEMANAGER_H_INCLUDED__

#include "csutil/refarr.h"
#include "csutil/ref.h"
#include "csutil/hash.h"

#include "app/icsseditmodemanager.h"
#include "plugins/icsseditmode.h"
#include "app/icsstudio.h"



class cssEditModeManagerPlugin : public icssPlugin
{
  csRef<icssEditMode> m_activeEM;

  //// array of callback to be fired if EM changes
  csRefArray<icssEditModeManagerCB> m_callbacks;
  //csHash<csRef<icssPlugin>, csStrKey, csConstCharHashKeyHandler> m_emplugs;
  csHash<csRef<icssPlugin>, csStrKey> m_emplugs;
  iCStudioCS* m_csi;

public:
  cssEditModeManagerPlugin(iBase *parent);
  virtual ~cssEditModeManagerPlugin();

  virtual bool Initialize(iCStudioCS *csi);
	virtual const char *GetName();

  //// icssEditModeManager interface
  void SetActiveEditMode (icssEditMode *newactive);
  icssEditMode* GetActiveEditMode ();
  void AddCallBack (icssEditModeManagerCB *toadd);
  void RemoveCallBack (icssEditModeManagerCB *torem);
  csPtr<icssEditMode> GetEM(const char* name);
  class cssEditModeManager : public icssEditModeManager
  {
    SCF_DECLARE_EMBEDDED_IBASE(cssEditModeManagerPlugin);
    virtual void SetActiveEditMode (icssEditMode *newactive)
    { scfParent->SetActiveEditMode(newactive); };
    virtual icssEditMode* GetActiveEditMode ()
    { return scfParent->GetActiveEditMode(); };
    virtual void AddCallBack (icssEditModeManagerCB *toadd)
    { scfParent->AddCallBack(toadd); };
    virtual void RemoveCallBack (icssEditModeManagerCB *torem)
    { scfParent->RemoveCallBack(torem); };
    virtual csPtr<icssEditMode> GetEM(const char* name)
    { return scfParent->GetEM(name); };
  } scficssEditModeManager;

	void LoadEditModes();
	
  SCF_DECLARE_IBASE;

};

#endif
