#ifndef __MESHOBJMOVE_H_INCLUDED__
#define __MESHOBJMOVE_H_INCLUDED__

#include "action/icssmoveaction.h"

#include "csgeom/vector3.h"
#include "csutil/refarr.h"
#include "plugins/icssplugin.h"

struct iMeshWrapper;


class cssSelMoveAction : public icssAction
{
	SCF_DECLARE_IBASE;

  csVector3 m_lastmove;
	csVector3 m_move;
  csRef<icssPlugin> m_selplug;

public:
	cssSelMoveAction(iBase* parent);
	virtual ~cssSelMoveAction();

	//// icssAction interface
	virtual bool Initialize(iCStudioCS *csi);
	virtual bool Do();
	virtual bool Undo();
	virtual bool Redo();
	virtual const char *GetDescription()
      { return "Move Selection"; }

	void MovePolygon(int polyidx, iMeshWrapper *cm, const csVector3 &dir);

	//// icssMoveAction methods

  void UpdateMoveAll();
  void MoveAll(csVector3 dir);
	void AddMove(csVector3 dir);

  class cssMoveAction : public icssMoveAction
  {
    SCF_DECLARE_EMBEDDED_IBASE(cssSelMoveAction);
    virtual void AddMove(csVector3 dir)
    { scfParent->AddMove(dir); };
  } scficssMoveAction;
  friend class cssMoveAction;

};

#endif
