#include "cssysdef.h"

#include "mapbrowser.h"

#include "mapbrowserpanel.h"

CS_IMPLEMENT_PLUGIN;

SCF_IMPLEMENT_FACTORY(cssMapBrowserPlugin);

SCF_IMPLEMENT_IBASE(cssMapBrowserPlugin)
SCF_IMPLEMENTS_INTERFACE(icssPlugin)
SCF_IMPLEMENTS_EMBEDDED_INTERFACE(icssSidePanelTabs)
SCF_IMPLEMENTS_EMBEDDED_INTERFACE(icssContentCallback)
SCF_IMPLEMENTS_EMBEDDED_INTERFACE(icssActiveSectorCallback)
SCF_IMPLEMENT_IBASE_END

SCF_IMPLEMENT_EMBEDDED_IBASE(cssMapBrowserPlugin::cssSidePanelTabs)
SCF_IMPLEMENTS_INTERFACE(icssSidePanelTabs)
SCF_IMPLEMENT_EMBEDDED_IBASE_END

SCF_IMPLEMENT_EMBEDDED_IBASE(cssMapBrowserPlugin::cssContentCallback)
SCF_IMPLEMENTS_INTERFACE(icssContentCallback)
SCF_IMPLEMENT_EMBEDDED_IBASE_END

SCF_IMPLEMENT_EMBEDDED_IBASE(cssMapBrowserPlugin::cssActiveSectorCallback)
SCF_IMPLEMENTS_INTERFACE(icssActiveSectorCallback)
SCF_IMPLEMENT_EMBEDDED_IBASE_END

cssMapBrowserPlugin::cssMapBrowserPlugin(iBase *parent)
{
  SCF_CONSTRUCT_IBASE(parent);
  SCF_CONSTRUCT_EMBEDDED_IBASE(scficssSidePanelTabs);
  SCF_CONSTRUCT_EMBEDDED_IBASE(scficssContentCallback);
  SCF_CONSTRUCT_EMBEDDED_IBASE(scficssActiveSectorCallback);
}

cssMapBrowserPlugin::~cssMapBrowserPlugin()
{
  SCF_DESTRUCT_EMBEDDED_IBASE(scficssActiveSectorCallback);
  SCF_DESTRUCT_EMBEDDED_IBASE(scficssContentCallback);
  SCF_DESTRUCT_EMBEDDED_IBASE(scficssSidePanelTabs);
  SCF_DESTRUCT_IBASE();
  
}

bool cssMapBrowserPlugin::Initialize(iCStudioCS *csi)
{
  m_csi = csi;
  m_mbpanel = 0;
  csRef<icssContentCallback> ccb = SCF_QUERY_INTERFACE(this, icssContentCallback);
  m_csi->RegisterContentCB(ccb);

  csRef<icssActiveSectorCallback> ascb = SCF_QUERY_INTERFACE(this, icssActiveSectorCallback);
  m_csi->RegisterActiveSectorCB(ascb);
  return true;
}

int cssMapBrowserPlugin::GetPanelCount()
{
  return 1;
}

wxPanel *cssMapBrowserPlugin::GetPanel(int idx, wxNotebook *parent)
{
  if(idx == 0)
  {
    if(!m_mbpanel)
      m_mbpanel = new cssMapBrowserPanel(this, parent);
    else if(m_mbpanel->GetParent() != parent)
      return 0;
    return m_mbpanel;
  }

  return 0;
}

const char *cssMapBrowserPlugin::GetPanelName(int idx)
{
  if(idx == 0)
    return "Map Browser";
  return 0; 
}

void cssMapBrowserPlugin::OnMeshListChanged()
{
  if(m_mbpanel)
    m_mbpanel->FillTree();
}

void cssMapBrowserPlugin::OnMaterialListChanged()
{
}

void cssMapBrowserPlugin::OnSectorListChanged()
{
}

void cssMapBrowserPlugin::OnActiveSectorChanged()
{
  if(m_mbpanel)  
    m_mbpanel->FillTree();
}
