#ifndef __MAPBROWSER_H_INCLUDED__
#define __MAPBROWSER_H_INCLUDED__

#include "plugins/icssplugin.h"
#include "plugins/icsssidepaneltabs.h"
#include "app/icsstudio.h"

class cssMapBrowserPanel;

class cssMapBrowserPlugin : public icssPlugin
{
public:

  iCStudioCS* m_csi;
  cssMapBrowserPanel *m_mbpanel;

  
  cssMapBrowserPlugin(iBase *parent);
  virtual ~cssMapBrowserPlugin();

	/// icssPlugin implementation
	virtual bool Initialize(iCStudioCS *csi);
	virtual const char *GetName()
	{ return "cstudio.plugin.mapbrowser"; };

	/// icssSidePanelTabs interface
  int GetPanelCount();
  wxPanel *GetPanel(int idx, wxNotebook *parent);
	const char *GetPanelName(int idx);
  class cssSidePanelTabs : public icssSidePanelTabs
  {
  public:
    SCF_DECLARE_EMBEDDED_IBASE(cssMapBrowserPlugin);
    virtual int Count()
    { return scfParent->GetPanelCount(); };
    virtual wxPanel * GetPanel(int idx, wxNotebook *parent)
    { return scfParent->GetPanel(idx, parent); };
		virtual const char * GetPanelName(int idx)
		{ return scfParent->GetPanelName(idx); };
  }scficssSidePanelTabs;
  friend class cssSidePanelTabs;

  /// icssContentCallback interface
  void OnMeshListChanged();
  void OnMaterialListChanged();
  void OnSectorListChanged();
  class cssContentCallback : public icssContentCallback
  {
    SCF_DECLARE_EMBEDDED_IBASE(cssMapBrowserPlugin);
    virtual void OnMeshListChanged()
    { scfParent->OnMeshListChanged(); };
    virtual void OnSectorListChanged()
    { scfParent->OnSectorListChanged(); };
    virtual void OnMaterialListChanged()
    { scfParent->OnMaterialListChanged(); };
  }scficssContentCallback;
  friend class cssContentCallback;

  /// icssActiveSectorCallback interface
  void OnActiveSectorChanged();
  class cssActiveSectorCallback : public icssActiveSectorCallback
  {
    SCF_DECLARE_EMBEDDED_IBASE(cssMapBrowserPlugin);
    virtual void OnActiveSectorChanged()
    { scfParent->OnActiveSectorChanged(); };
  } scficssActiveSectorCallback;
  friend class cssActiveSectorCallback;

  SCF_DECLARE_IBASE;
};


#endif
