#ifndef __MAPBROWSERPANEL_H_INCLUDED__
#define __MAPBROWSERPANEL_H_INCLUDED__

#include "csutil/ref.h"


#include "wx/notebook.h"
#include "wx/panel.h"
#include "wx/treectrl.h"

struct iMeshWrapper;
struct iLight;
struct iCStudioCS;
struct icssActionManager;
class cssMapBrowserPlugin;

class cssMapBrowserPanel : public wxPanel
{
  wxTreeItemId rootid, thingsid, genmeshid, lightid;

  csRef<icssSelection> m_sel;
  icssPlugin *m_selplug;
  iCStudioCS *m_csi;
  cssMapBrowserPlugin *mapbrowser;
  
  csRef<icssActionManager> m_actionmgr;

  wxTreeCtrl *m_tree;
public:
  cssMapBrowserPanel (cssMapBrowserPlugin *mapbrowser,  wxNotebook *parent);
  virtual ~cssMapBrowserPanel();

	void GetActionManager();
  void FillTree();
  void AddThingMesh(iMeshWrapper *mwrap);
  void AddGenMesh(iMeshWrapper *mwrap);
  void AddLight(iLight *light);

	void OnRightClickItem (wxTreeEvent &e);
	void OnSelectItem (wxCommandEvent &e);
  void OnAddToSelection (wxCommandEvent &e);

  enum imageId
	{
		IMAGE_NOT_SELECTED,
		IMAGE_SELECTED,
		IMAGE_COUNT		//Should always be at the bottom.
	};
  wxImageList* CreateImageList();
  wxImageList* imageList;
	int imageIdList[IMAGE_COUNT];

  DECLARE_EVENT_TABLE();
};


#endif
