#include "cssysdef.h"

#include "plugins/icssselection.h"
#include "app/icsstudio.h"

#include "addselection.h"

SCF_IMPLEMENT_IBASE(cssAddSelectionAction)
SCF_IMPLEMENTS_INTERFACE(icssAction)
SCF_IMPLEMENTS_EMBEDDED_INTERFACE(icssAddSelectionAction)
SCF_IMPLEMENT_IBASE_END

SCF_IMPLEMENT_EMBEDDED_IBASE(cssAddSelectionAction::cssAddSelAction)
SCF_IMPLEMENTS_INTERFACE(icssAddSelectionAction)
SCF_IMPLEMENT_EMBEDDED_IBASE_END

SCF_IMPLEMENT_FACTORY(cssAddSelectionAction);

cssAddSelectionAction::cssAddSelectionAction(iBase *parent)
{
	SCF_CONSTRUCT_IBASE(parent);
	SCF_CONSTRUCT_EMBEDDED_IBASE(scficssAddSelectionAction);
}

cssAddSelectionAction::~cssAddSelectionAction()
{
	SCF_DESTRUCT_EMBEDDED_IBASE(scficssAddSelectionAction);
	SCF_DESTRUCT_IBASE();
}

//// icssAction implementation
bool cssAddSelectionAction::Initialize(iCStudioCS *csi)
{
	m_selplug = csi->GetPlugin("cstudio.select.defselect");
	return true;
}

bool cssAddSelectionAction::Do()
{
  	csRef<icssSelection> sel = SCF_QUERY_INTERFACE(m_selplug, icssSelection);
  	if(!sel)
    		return false;
  	size_t toaddcount = m_objtoadd.Length();
  	for(size_t i = 0; i < toaddcount; i++)
  	{
    		sel->Add(m_objtoadd.Get(i));
  	}

  	return true;
}

bool cssAddSelectionAction::Undo()
{
  	csRef<icssSelection> sel = SCF_QUERY_INTERFACE(m_selplug, icssSelection);
  	if(!sel)
    		return false;
  	size_t toaddcount = m_objtoadd.Length();
  	for(size_t i = 0; i < toaddcount; i++)
  	{
    		sel->Remove(m_objtoadd.Get(i));
  	}
  	return true;
}

bool cssAddSelectionAction::Redo()
{
  	Do();
  	return true;
}

//// icssAddSelectionAction implementation
void cssAddSelectionAction::Add(iBase *toadd)
{
  	m_objtoadd.PushSmart(toadd);
}

