#include "cssysdef.h"

#include "clearselection.h"

#include "app/icsstudio.h"
#include "plugins/icssselection.h"

SCF_IMPLEMENT_IBASE(cssClearSelectionAction)
SCF_IMPLEMENTS_INTERFACE(icssAction)
SCF_IMPLEMENT_IBASE_END

SCF_IMPLEMENT_FACTORY(cssClearSelectionAction);

cssClearSelectionAction::cssClearSelectionAction(iBase *parent)
{
	SCF_CONSTRUCT_IBASE(parent);
}

cssClearSelectionAction::~cssClearSelectionAction()
{
	SCF_DESTRUCT_IBASE();
}

bool cssClearSelectionAction::Initialize(iCStudioCS *csi)
{
	m_selplug = csi->GetPlugin("cstudio.select.defselect");
	return true;
}

bool cssClearSelectionAction::Do()
{
	//// save selection for undo
	csRef<icssSelection> sel = SCF_QUERY_INTERFACE(m_selplug, icssSelection);
	sel->SaveToArray(m_selbackup);
	sel->Clear();
	return true;
}

bool cssClearSelectionAction::Undo()
{
	csRef<icssSelection> sel = SCF_QUERY_INTERFACE(m_selplug, icssSelection);
	sel->LoadFromArray(m_selbackup);
	return true;
}

bool cssClearSelectionAction::Redo()
{
	Do();
	return true;
}

