#include "cssysdef.h"

#include "thingpartsel.h"
#include "iengine/mesh.h"

SCF_IMPLEMENT_IBASE(cssThingPart)
SCF_IMPLEMENTS_INTERFACE(icssThingPart)
SCF_IMPLEMENT_IBASE_END

SCF_IMPLEMENT_FACTORY(cssThingPart);

cssThingPart::cssThingPart(iBase *parent)
{
	SCF_CONSTRUCT_IBASE(parent);
}

cssThingPart::~cssThingPart()
{
	SCF_DESTRUCT_IBASE();
}

/// icssThingPartSelection interface implementation
int cssThingPart::GetVertexCount()
{
	return m_selverts.Length();
}

int cssThingPart::GetPolygonCount()
{
	return m_selpolys.Length();
}

int cssThingPart::GetVertexIndex(int vertidx)
{
	return m_selverts[vertidx];
}

int cssThingPart::GetPolygonIndex(int polyidx)
{
	return m_selpolys[polyidx];
}

void cssThingPart::AddVertex(int vertidx)
{
	// push smart to avoid double selection
	m_selverts.PushSmart(vertidx);
}

void cssThingPart::AddPolygon(int polyidx)
{
	// push smart to avoid double selection
	m_selpolys.PushSmart(polyidx);

	/// @@@@ TBD: we have to deselect all vertices from
	/// selverts which are in the polyidx, otherwise
	/// those could get double selected

}

void cssThingPart::SetMesh(iMeshWrapper *mwrap)
{
	m_mwrap = mwrap;
}

iMeshWrapper * cssThingPart::GetMesh()
{
	return m_mwrap;
}

