#ifndef __LIGHTSELECTOR_H_INCLUDED__
#define __LIGHTSELECTOR_H_INCLUDED__

#include "plugins/icssselector.h"
#include "plugins/icssplugin.h"

class cssLightSelector: public icssPlugin
{
  iCStudioCS* m_csi;
public:

  cssLightSelector(iBase *parent);
  virtual ~cssLightSelector();

  SCF_DECLARE_IBASE;

  virtual bool Initialize(iCStudioCS *csi);
  virtual const char *GetName();

  int HitBeam(const csVector3 &begin, const csVector3 &end, float radius, csRefArray<iBase> &result);
  int InBBox(csBox3 &bbox, csRefArray<iBase> &result);
  class eicssMeshSelector : public icssSelector
  {
    SCF_DECLARE_EMBEDDED_IBASE(cssLightSelector);
    int HitBeam(const csVector3 &begin, const csVector3 &end, float radius, csRefArray<iBase> &result)
    { return scfParent->HitBeam(begin, end, radius, result); };
    int InBBox(csBox3 &bbox, csRefArray<iBase> &result)
    { return scfParent->InBBox(bbox, result); };
  } scficssSelector;

};

#endif
