#include "cssysdef.h"

#include "meshselector.h"

#include "iengine/sector.h"
#include "iengine/mesh.h"
#include "csutil/refarr.h"


#include "app/icsstudio.h"

CS_IMPLEMENT_PLUGIN

SCF_IMPLEMENT_FACTORY(cssMeshSelectorPlugin);

SCF_IMPLEMENT_IBASE(cssMeshSelectorPlugin)
SCF_IMPLEMENTS_INTERFACE(icssPlugin)
SCF_IMPLEMENTS_EMBEDDED_INTERFACE(icssSelector)
SCF_IMPLEMENT_IBASE_END

SCF_IMPLEMENT_EMBEDDED_IBASE(cssMeshSelectorPlugin::cssMeshSelector)
SCF_IMPLEMENTS_INTERFACE(icssSelector)
SCF_IMPLEMENT_IBASE_END

cssMeshSelectorPlugin::cssMeshSelectorPlugin(iBase *parent)
{
  SCF_CONSTRUCT_IBASE(parent);
  SCF_CONSTRUCT_EMBEDDED_IBASE(scficssSelector);
}


cssMeshSelectorPlugin::~cssMeshSelectorPlugin()
{
  SCF_DESTRUCT_EMBEDDED_IBASE(scficssSelector);
  SCF_DESTRUCT_IBASE();
}

bool cssMeshSelectorPlugin::Initialize(iCStudioCS *csi)
{
	m_csi = csi;
	return true;
}

const char *cssMeshSelectorPlugin::GetName()
{
	return "cstudio.select.object.mesh";
}

int cssMeshSelectorPlugin::HitBeam(const csVector3 &begin, 
	const csVector3 &end, 
	float radius, 
	csRefArray<iBase> &result)
{
	csRef<iSector> active_sector = m_csi->getActiveSector();
	if(active_sector)
	{
    csVector3 hitpoint;
    csRef<iMeshWrapper> hit = active_sector->HitBeam(begin, end, hitpoint, 0, true);
    if(hit)
    {
      result.PushSmart(hit);
      return 1;
    }
	}
	return 0;
}

int cssMeshSelectorPlugin::InBBox(csBox3 &bbox, csRefArray<iBase> &result)
{
	/// TBD
	return 0;
}
