#ifndef __OBJECTSELECTOR_H_INCLUDED__
#define __OBJECTSELECTOR_H_INCLUDED__

#include "plugins/icssselector.h"
#include "plugins/icssplugin.h"

class cssObjectSelector : public icssPlugin
{
  iCStudioCS* m_csi;
  
  csRefArray<icssSelector> selectors;
  
public:
  cssObjectSelector(iBase *parent);
  virtual ~cssObjectSelector();

  SCF_DECLARE_IBASE;

  virtual bool Initialize(iCStudioCS *csi);
  virtual const char *GetName();

  int HitBeam(const csVector3 &begin, const csVector3 &end, float radius, csRefArray<iBase> &result);
  int InBBox(csBox3 &bbox, csRefArray<iBase> &result);
  class eicssSelector : public icssSelector
  {
    SCF_DECLARE_EMBEDDED_IBASE(cssObjectSelector );
    int HitBeam(const csVector3 &begin, const csVector3 &end, float radius, csRefArray<iBase> &result)
    { return scfParent->HitBeam(begin, end, radius, result); };
    int InBBox(csBox3 &bbox, csRefArray<iBase> &result)
    { return scfParent->InBBox(bbox, result); };
  } scficssSelector;

};

#endif
