/*
    Copyright (C) 2003 by Philipp Aumayr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "cst-config.h"
#include "wx/wxprec.h"

#ifndef WX_PRECOMP
        #include "wx/wx.h"
#endif

#include "clickwindow.h"


BEGIN_EVENT_TABLE(cssClickWindow, wxWindow)
  EVT_RIGHT_DCLICK(cssClickWindow::OnLeftDblClick)
	EVT_PAINT(cssClickWindow::OnPaint) 
END_EVENT_TABLE()

cssClickWindow::cssClickWindow(wxWindow* parent, 
									wxWindowID id, 
									const wxPoint& pos, 
									const wxSize& size, 
									long style, 
									const wxString& name)
									: wxWindow(parent, id, pos, size, style, name)
{
}
									
cssClickWindow::~cssClickWindow()
{
}
	
void cssClickWindow::OnLeftDblClick(wxMouseEvent &ev)
{
	GetParent()->ProcessEvent(ev);
}

void cssClickWindow::OnPaint(wxPaintEvent &ev)
{
	wxPaintDC dc(this);
	dc.DrawText("Click here to insert a better view :)!", GetRect().GetWidth() / 4, GetRect().GetHeight() / 2);
}
