/*
    Copyright (C) 2003 by Philipp Aumayr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "cst-config.h"
#include "wx/wxprec.h"

#ifndef WX_PRECOMP
        #include "wx/wx.h"
#endif

#include "wx/app.h"
#include "cssysdef.h"


#include "app/icsstudio.h"

#include "splitview.h"
#include "splitviewwnd.h"


CS_IMPLEMENT_PLUGIN

SCF_IMPLEMENT_IBASE(cssSplitViewPlg)
SCF_IMPLEMENTS_INTERFACE(icssPlugin)
SCF_IMPLEMENTS_EMBEDDED_INTERFACE(icssCreateView)
SCF_IMPLEMENT_IBASE_END

SCF_IMPLEMENT_EMBEDDED_IBASE(cssSplitViewPlg::cssCreateView)
SCF_IMPLEMENTS_INTERFACE(icssCreateView)
SCF_IMPLEMENT_EMBEDDED_IBASE_END

SCF_IMPLEMENT_FACTORY (cssSplitViewPlg)

cssSplitViewPlg::cssSplitViewPlg(iBase *parent)
{
	SCF_CONSTRUCT_IBASE(parent);
	SCF_CONSTRUCT_EMBEDDED_IBASE(scficssCreateView);
	m_splitview = NULL;
}

cssSplitViewPlg::~cssSplitViewPlg()
{
	SCF_DESTRUCT_EMBEDDED_IBASE(scficssCreateView);
	SCF_DESTRUCT_IBASE();
}

/// icssPlugin implementation
bool cssSplitViewPlg::Initialize(iCStudioCS *csi)
{
  m_csi = csi;
	return true;
}

/// icssView implementation
wxWindow* cssSplitViewPlg::cssCreateView::Create(wxWindow *parent, const wxChar *title, 
																					 int posx, int posy, int sizex, int sizey)
{
	scfParent->m_splitview = new cssSplitViewWnd(scfParent->m_csi, parent, -1); 
	scfParent->m_splitview->Show(TRUE);
	return scfParent->m_splitview;
}
