/*
    Copyright (C) 2003 by Philipp Aumayr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __SPLITVIEW_H_INCLUDED__
#define __SPLITVIEW_H_INCLUDED__

#include "plugins/icssplugin.h"
#include "plugins/icsscontextmenu.h"
#include "plugins/icsscreateview.h"

class wxSplitterWindow;

class cssSplitViewPlg : public icssPlugin
{
  iCStudioCS* m_csi;
	wxSplitterWindow *m_splitview;
public:
	SCF_DECLARE_IBASE;

	cssSplitViewPlg(iBase *parent);
	virtual ~cssSplitViewPlg();

	/// icssPlugin implementation
	virtual bool Initialize(iCStudioCS *csi);
	virtual const char *GetName()
	{ return "cstudio.view.splitview"; };

	/// icssCreateView embedded interface for creating a 2D view
	class cssCreateView : public icssCreateView
	{
	public:
		SCF_DECLARE_EMBEDDED_IBASE(cssSplitViewPlg);
		virtual wxWindow* Create(wxWindow *parent,
                      const wxChar *title, int posx, int posy, int sizex, int sizey);
    virtual bool SaveXML(wxWindow *wnd, iDocumentNode *parent)
    { return true; }; // tbd
    virtual bool LoadXML(wxWindow *wnd, iDocumentNode *parent)
    { return true; }; // tbd
	} scficssCreateView;
	friend class cssCreateView;

};




#endif
