/*
    Copyright (C) 2003 by Philipp Aumayr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __SPLITVIEWWND_H_INCLUDED__
#define __SPLITVIEWWND_H_INCLUDED__

#include <wx/splitter.h>

struct icssPlugin;
struct iCStudioCS;


class cssSplitViewWnd : public wxSplitterWindow
{
  iCStudioCS* m_csi;
  icssPlugin* plugleft, *plugright;
public:
  wxWindow *left, *right;
	cssSplitViewWnd(iCStudioCS *csi, wxWindow* parent, 
									 wxWindowID id, 
									 const wxPoint& point = wxDefaultPosition, 
									 const wxSize& size = wxDefaultSize,
									 long style=wxSP_3D, 
									 const wxString& name = "splitterWindow");
	
	virtual ~cssSplitViewWnd();
	
	void OnLeftDClick(wxMouseEvent &ev);
	void OnEraseBackground(wxEraseEvent& event);

	DECLARE_EVENT_TABLE()
};


#endif
