/*
    Copyright (C) 2005 by Jan Lepper

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "cssysdef.h"
#include "splitview4.h"
#include "splitview4wnd.h"

CS_IMPLEMENT_PLUGIN;

SCF_IMPLEMENT_FACTORY(cssSplitView4);

SCF_IMPLEMENT_IBASE(cssSplitView4)
  SCF_IMPLEMENTS_INTERFACE(icssPlugin)
  SCF_IMPLEMENTS_EMBEDDED_INTERFACE(icssCreateView)
SCF_IMPLEMENT_IBASE_END

SCF_IMPLEMENT_EMBEDDED_IBASE(cssSplitView4::eicssCreateView)
  SCF_IMPLEMENTS_INTERFACE(icssCreateView)
SCF_IMPLEMENT_EMBEDDED_IBASE_END


cssSplitView4::cssSplitView4(iBase *parent)
{
  SCF_CONSTRUCT_IBASE(parent);
  SCF_CONSTRUCT_EMBEDDED_IBASE(scficssCreateView);
}

cssSplitView4::~cssSplitView4()
{
  SCF_DESTRUCT_EMBEDDED_IBASE(scficssCreateView);
  SCF_DESTRUCT_IBASE();
}

bool cssSplitView4::Initialize(iCStudioCS *csi)
{
  this->csi = csi;
  return true;
}

wxWindow *cssSplitView4::Create(wxWindow *parent, int posx, int posy, int sizex, int sizey)
{
  return new cssSplitView4Wnd(parent, csi, wxPoint(posx, posy), wxSize(sizex, sizey));
}
