/*
    Copyright (C) 2005 by Jan Lepper

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __CSS_SPLITVIEW4_INCLUDED__
#define __CSS_SPLITVIEW4_INCLUDED__

#include "plugins/icssplugin.h"
#include "plugins/icsscreateview.h"

#include "splitview4wnd.h"

struct iCStudioCS;
class wxWindow;

class cssSplitView4 : public icssPlugin
{
  iCStudioCS *csi;
public:
  SCF_DECLARE_IBASE;
  
  cssSplitView4(iBase *parent);
  virtual ~cssSplitView4();
  
  /// icssPlugin functions
  virtual bool Initialize(iCStudioCS *csi);
  virtual const char *GetName()
  { return "cstudio.view.splitview4"; }
  
  struct eicssCreateView : public icssCreateView
  {
    SCF_DECLARE_EMBEDDED_IBASE(cssSplitView4);
    virtual wxWindow* Create(wxWindow *parent,
      const char *title, int posx, int posy, int sizex, int sizey)
    { return scfParent->Create(parent, posx, posy, sizex, sizey); }
    virtual bool SaveXML(wxWindow *wnd, iDocumentNode *parent)
    { return ((cssSplitView4Wnd*)wnd)->Save(parent); };
    virtual bool LoadXML(wxWindow *wnd, iDocumentNode *parent)
    { return ((cssSplitView4Wnd*)wnd)->Load(parent); };
  } scficssCreateView;
  friend struct scficssCreateView;
  
  wxWindow *Create(wxWindow *parent, int posx, int posy, int sizex, int sizey);
};

#endif
