#ifndef __DRAWER_H_INCLUDED__
#define __DRAWER_H_INCLUDED__

#include "plugins/icssdrawer.h"

#include "view2dgrid.h"

class cssView2DWnd;
struct iCStudioCS;
struct iPolygonMesh;

class cssDrawer : public icssDrawer
{
  iCStudioCS *m_csi; 
  csColor4 draw_color;
  int  stipple_factor;
  unsigned short stipple_pattern;
  float line_width;  
  float point_size;

  csVector3 bbox_verts[8];
  unsigned short bbox_indices[24];

  csVector2 circle_verts[360]; // max 1 line per 1 

public:
  cssDrawer ();
  virtual ~cssDrawer ();
 
  void Initialize(iCStudioCS *csi);

  virtual void SetColor(csColor4 &c);
  virtual csColor4 &GetColor();
  virtual void SetLineStipple(int factor, unsigned short pattern);
  virtual void GetLineStipple(int &ofactor, unsigned short &opattern);
  virtual void SetLineWidth (float width); 
  virtual float GetLineWidth (); 
  virtual void SetPointSize (float size);
  virtual float GetPointSize ();
 
  virtual void DrawMesh (iMeshWrapper *m);
  virtual void DrawLight(iLight *light);
  virtual void DrawObject(iBase *object);
  virtual void DrawAABB (csVector3 &min, csVector3 &max);
  virtual void DrawPoint (csVector3 &p);
  virtual void DrawCircle (csVector3 &m, float r, int segcount = 12);
  virtual void DrawLine (csVector3 &s, csVector3 &e);
 
  void DrawPolyMesh(iPolygonMesh *pm);
 
  void ApplyTransform (const csReversibleTransform& t);
  
  void DrawSelectedMeshes(iSector *s);
  void LoadBBoxVerts(csVector3 &min, csVector3 &max);
  void CalculateCircleVerts(int segcount);
  SCF_DECLARE_IBASE;
};



#endif

