/*
    Copyright (C) 2003 by Philipp Aumayr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "cst-config.h"
#include "wx/wxprec.h"

#ifndef WX_PRECOMP
        #include "wx/wx.h"
#endif

#include "wx/app.h"

#include "cssysdef.h"
#include "csutil/hash.h"

#include "view2d.h"

#include "view2dwnd.h"

CS_IMPLEMENT_PLUGIN

SCF_IMPLEMENT_IBASE(cssView2DPlugin)
SCF_IMPLEMENTS_INTERFACE(icssPlugin)
SCF_IMPLEMENTS_EMBEDDED_INTERFACE(icssCreateView)
SCF_IMPLEMENTS_EMBEDDED_INTERFACE(icssShowSettingsDlg)
SCF_IMPLEMENT_IBASE_END

SCF_IMPLEMENT_EMBEDDED_IBASE(cssView2DPlugin::cssCreateView)
SCF_IMPLEMENTS_INTERFACE(icssCreateView)
SCF_IMPLEMENT_EMBEDDED_IBASE_END

SCF_IMPLEMENT_EMBEDDED_IBASE(cssView2DPlugin::cssShowSettingsDlg)
SCF_IMPLEMENTS_INTERFACE(icssShowSettingsDlg)
SCF_IMPLEMENT_EMBEDDED_IBASE_END

SCF_IMPLEMENT_FACTORY (cssView2DPlugin)

cssView2DPlugin::cssView2DPlugin(iBase *parent)
{
	SCF_CONSTRUCT_IBASE(parent);
	SCF_CONSTRUCT_EMBEDDED_IBASE(scficssShowSettingsDlg);
	SCF_CONSTRUCT_EMBEDDED_IBASE(scficssCreateView);

}

cssView2DPlugin::~cssView2DPlugin()
{
	SCF_DESTRUCT_EMBEDDED_IBASE(scficssShowSettingsDlg);
	SCF_DESTRUCT_EMBEDDED_IBASE(scficssCreateView);
	SCF_DESTRUCT_IBASE();
}

/// cssPlugin implemenation

bool cssView2DPlugin::Initialize( iCStudioCS *csi)
{
	this->csi = csi;
	return true;
}


/// cssCreateView implementation

wxWindow* cssView2DPlugin::cssCreateView::Create(wxWindow *parent,
                      const wxChar *title, int posx, int posy, int sizex, int sizey)
{
	wxWindow *window = new ::cssView2DWnd(parent, -1, wxPoint(posx, posy), wxSize(sizex, sizey),
		0, title, (iCStudioCS*)scfParent->csi);

	window->Show(TRUE);
	return window;
}

bool cssView2DPlugin::cssCreateView::SaveXML(wxWindow *wnd, iDocumentNode *parent)
{
  cssView2DWnd *wnd2d = (cssView2DWnd *)wnd;
  return wnd2d->SaveXML(parent);
}

bool cssView2DPlugin::cssCreateView::LoadXML(wxWindow *wnd, iDocumentNode *parent)
{
  cssView2DWnd *wnd2d = (cssView2DWnd *)wnd;
  return wnd2d->LoadXML(parent);
}

/// cssShowSettingsDlg implementation
cssView2DPlugin::cssShowSettingsDlg::cssShowSettingsDlg(iBase *parent)
{
}

bool cssView2DPlugin::cssShowSettingsDlg::ShowSettingsDialog()
{
	return true;
}
