/*
    Copyright (C) 2003 by Philipp Aumayr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __CSSVIEW2DGRID_H_INCLUDED__
#define __CSSVIEW2DGRID_H_INCLUDED__

#include "csutil/cscolor.h"
#include "csutil/dirtyaccessarray.h"
#include "csgeom/vector2.h"

class cssView2DGrid
{
  csDirtyAccessArray <csVector2> griddata;
  float minx, maxx, miny, maxy;
public:

  cssView2DGrid();
  ~cssView2DGrid();
  void GenerateGridLines(float startx, float endx, float stepx,
                         float starty, float endy, float stepy);
  void DrawGrid(csColor rgb);
  void DrawOrigin(csColor rgb);
};


#endif
