#include "cssysdef.h"

CS_IMPLEMENT_PLUGIN

#include "iengine/engine.h"
#include "ivideo/natwin.h"
#include "ivideo/wxwin.h"
#include "ivideo/graph2d.h"
#include "ivideo/graph3d.h"
#include "iutil/objreg.h"
#include "app/icsstudio.h"
#include "viewcs.h"

SCF_IMPLEMENT_IBASE(cssViewCSPlugin)
SCF_IMPLEMENTS_INTERFACE(icssPlugin)
SCF_IMPLEMENTS_EMBEDDED_INTERFACE(icssCreateView)
SCF_IMPLEMENT_IBASE_END

SCF_IMPLEMENT_EMBEDDED_IBASE(cssViewCSPlugin::cssCreateView)
SCF_IMPLEMENTS_INTERFACE(icssCreateView)
SCF_IMPLEMENT_IBASE_END

SCF_IMPLEMENT_FACTORY(cssViewCSPlugin)


cssViewCSPlugin::cssViewCSPlugin (iBase *parent)
{
  SCF_CONSTRUCT_IBASE(parent);
  SCF_CONSTRUCT_EMBEDDED_IBASE(scficssCreateView);
}

cssViewCSPlugin::~cssViewCSPlugin ()
{
  SCF_DESTRUCT_EMBEDDED_IBASE(scficssCreateView);
  SCF_DESTRUCT_IBASE();
}

bool cssViewCSPlugin::Initialize(iCStudioCS *csi)
{
  this->csi = csi;

  csRef<iEngine> engine = 
    CS_QUERY_REGISTRY(csi->getObjectRegistry(), iEngine);
  csRef<iGraphics3D> g3d = 
    CS_QUERY_REGISTRY(csi->getObjectRegistry(), iGraphics3D);

  view = csPtr<iView> (new csView (engine, g3d));
  iGraphics2D* g2d = g3d->GetDriver2D ();
  view->SetRectangle (0, 0, g2d->GetWidth (), g2d->GetHeight ());

  return true;
}

const char *cssViewCSPlugin::GetName()
{
  return "cstudio.view.viewcs";
}


wxWindow * cssViewCSPlugin::Create (wxWindow *parent, const wxChar *title,
                     int posx, int posy, int sizex, int sizey)
{
  iObjectRegistry *object_reg = csi->getObjectRegistry();

  csRef<iGraphics2D> g2d = CS_QUERY_REGISTRY(object_reg, iGraphics2D);

  csRef<iWxWindow> wxwin = SCF_QUERY_INTERFACE(g2d, iWxWindow);
  if(wxwin)
    return wxwin->GetWindow(); 

  return 0;
}


