#ifndef __VIEWCS_H_INCLUDED__
#define __VIEWCS_H_INCLUDED__

#include "cstool/csview.h"

#include "plugins/icssplugin.h"
#include "plugins/icsscreateview.h"

class wxWindow;

class cssViewCSPlugin : public icssPlugin
{
  iCStudioCS *csi;
  csRef<iView> view;
public:
  SCF_DECLARE_IBASE;

  cssViewCSPlugin(iBase *parent);
  virtual ~cssViewCSPlugin();

  virtual bool Initialize(iCStudioCS *csi);
  virtual const char *GetName();
  
  //// icssCreateView declaration and functions
  wxWindow * Create (wxWindow *parent, const wxChar *title,
                     int posx, int posy, int sizex, int sizey);


  class cssCreateView : public icssCreateView
  {
  public:
    SCF_DECLARE_EMBEDDED_IBASE(cssViewCSPlugin);
    virtual wxWindow * Create(wxWindow *parent, 
             const wxChar *title, int posx, int posy, int sizex, int sizey)
    { return scfParent->Create(parent, title, posx, posy, sizex, sizey); };
    virtual bool SaveXML(wxWindow *wnd, iDocumentNode *parent)
    { return true; }; // we don't need to save info for now (TBD)
    virtual bool LoadXML(wxWindow *wnd, iDocumentNode *parent)
    { return true; }; 
  } scficssCreateView;
  friend class cssCreateView;
};
#endif

