/*
    Copyright (C) 2003 by Philipp Aumayr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "cssysdef.h"

#include "wx/wxprec.h"

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "iutil/stringarray.h"

#include "app/icsstudio.h"
#include "plugins/icssplugin.h"
#include "plugins/icssselection.h"
#include "plugins/icsssidepaneltabs.h"


#include "cssmbnotebook.h"


cssMapBrowserNotebook::cssMapBrowserNotebook(iCStudioCS *csi, wxWindow *parent, wxWindowID id,
        const wxPoint& pos,
				const wxSize& size, long style) :
				wxNotebook(parent, id, pos, size, style)
{
  this->csi = csi;
}

cssMapBrowserNotebook::~cssMapBrowserNotebook()
{
}

void cssMapBrowserNotebook::LoadTabsfromPlugins()
{
  DeleteAllPages();
  size_t ncount = csi->GetPluginCount();
  for(size_t i = 0; i < ncount; i++)
  {
    csRef<icssPlugin> p = csi->GetPlugin(i);
    if(p)
    {
      csRef<icssSidePanelTabs> pspt = SCF_QUERY_INTERFACE(p, icssSidePanelTabs);
      if(pspt) // if the plugin has side panels, go get them
      {
        int psptcount = pspt->Count();
        for(int j = 0; j < psptcount; j++)
	{
          wxPanel *panel = pspt->GetPanel(j, this);
          if(panel)      
            InsertPage(0, panel, pspt->GetPanelName(j));
        }
      }
    }
  }
}

