/*
    Copyright (C) 2003 by Philipp Aumayr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "cst-config.h"
#include "wx/wxprec.h"

#ifndef WX_PRECOMP
        #include "wx/wx.h"
#endif

#include "cssysdef.h"

#include "plugins/icsscreateview.h"

#include "csschildframe.h"
#include "csswindowmanager.h"


BEGIN_EVENT_TABLE (cssChildFrame, wxFrame)
  EVT_CLOSE(cssChildFrame::OnClose)
END_EVENT_TABLE()



cssChildFrame::cssChildFrame(wxWindow *parent, const wxString& title, 
                       const wxPoint& pos, const wxSize& size, const long style, cssWindowManagerMultiframe *wm)
                : wxFrame(parent, -1, title, pos, size, style)
{
  mainframe = parent;
  windowmanager = wm;
  canvas = 0;
}
  
cssChildFrame::~cssChildFrame()
{
}

bool cssChildFrame::CreateCanvas(const char *plugin, iCStudioCS *csi)
{
  newplugin = SCF_CREATE_INSTANCE(plugin, icssPlugin);
  newplugin->Initialize(csi);
	
  newview = SCF_QUERY_INTERFACE(newplugin, icssCreateView);
  wxWindow *newwindow = newview->Create(this, "default", 100, 100, 500, 500);
  if(!newwindow)
  {
    return false;
  }
  canvas = newwindow;
  return true;
}

void cssChildFrame::DestroyCanvas()
{
  if(canvas)
    canvas->Destroy();
  canvas = 0;
  newplugin = 0;
}

void cssChildFrame::OnClose(wxCloseEvent& event)
{
  windowmanager->Remove(this);
  DestroyCanvas();
  Destroy();
}

void cssChildFrame::SaveXML(iDocumentNode *parent)
{
  newview->SaveXML(canvas, parent);
}

void cssChildFrame::LoadXML(iDocumentNode *parent)
{
  newview->LoadXML(canvas, parent);
}
