/*
    Copyright (C) 2003 by Philipp Aumayr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __CSSCHILDFRAME_H_INCLUDED__
#define __CSSCHILDFRAME_H_INCLUDED__


#include "csutil/ref.h"
#include <wx/frame.h> 


struct icssCreateView;
struct icssPlugin;
struct iCStudioCS;
class cssWindowManagerMultiframe;

class cssChildFrame : public wxFrame
{
  csRef<icssCreateView> newview;
  csRef<icssPlugin> newplugin;

  wxWindow *mainframe;
  wxWindow *canvas;
  cssWindowManagerMultiframe *windowmanager;
public:
  

  cssChildFrame(wxWindow *parent, const wxString& title, const wxPoint& pos, const wxSize& size, const long style,
                      cssWindowManagerMultiframe *wm);
  ~cssChildFrame();

  bool CreateCanvas(const char *plugin, iCStudioCS *csi);
  void DestroyCanvas();
  void SaveXML(iDocumentNode *parent);
  void LoadXML(iDocumentNode *parent);
	
  void OnClose(wxCloseEvent& event);

  wxWindow * GetMainFrame()
  { return mainframe; };
  wxWindow * GetCanvas() 
  { return canvas; };
  icssPlugin * GetPlugin()
  { return newplugin; };

  DECLARE_EVENT_TABLE();

};

#endif
