/*
    Copyright (C) 2003 by Philipp Aumayr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "wx/wxprec.h"

#ifndef WX_PRECOMP
        #include "wx/wx.h"
#endif

#include "cssysdef.h"

#include "cssmbframe.h"
#include "../common/cssmbnotebook.h"
#include "csswindowmanager.h"

BEGIN_EVENT_TABLE (cssMapBrowserFrame, wxFrame)
  EVT_CLOSE (cssMapBrowserFrame::OnWindowClose)
END_EVENT_TABLE()


cssMapBrowserFrame::cssMapBrowserFrame(iCStudioCS *csi, cssWindowManagerMultiframe *wm,
                      wxWindow* parent, wxWindowID id, 
                      const wxString& title, long style, 
                      const wxString& name)
		      : wxFrame(parent, id, title, wxDefaultPosition, 
		      wxDefaultSize, style, name)
{
  this->csi = csi;
  windowmanager = wm;

  notebook = new cssMapBrowserNotebook(csi, this, -1, wxPoint(0,0), wxSize(50, 50));
	
  wxNotebookSizer *sizerNotebook = new wxNotebookSizer(notebook);

  SetSizer(sizerNotebook);

  notebook->Show();
}

cssMapBrowserFrame::~cssMapBrowserFrame()
{
}

void cssMapBrowserFrame::OnWindowClose (wxCloseEvent& event)
{
  Hide ();
  windowmanager->GetMenu()->Check(CSS_WINDOW_SHOW_PANELS, false);
}

void cssMapBrowserFrame::ReloadPluginPages ()
{
  notebook->LoadTabsfromPlugins();
}

void cssMapBrowserFrame::UnloadPluginPages ()
{
  notebook->DeleteAllPages();
}


