/*
    Copyright (C) 2003 by Philipp Aumayr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __CSSMBFRAME_H_INCLUDED__
#define __CSSMBFRAME_H_INCLUDED__

#include "csutil/ref.h"
#include "app/icsstudio.h"

#include "wx/frame.h"

class cssMapBrowserNotebook;
class cssWindowManagerMultiframe;


class cssMapBrowserFrame : public wxFrame
{
  iCStudioCS* csi;
  cssMapBrowserNotebook *notebook;
  cssWindowManagerMultiframe *windowmanager;
public:

  void ReloadPluginPages ();
  void UnloadPluginPages();
  cssMapBrowserFrame(iCStudioCS *csi, cssWindowManagerMultiframe *wm,
                      wxWindow* parent, wxWindowID id, 
                      const wxString& title, long style = wxDEFAULT_FRAME_STYLE, 
                      const wxString& name = "frame");
  virtual ~cssMapBrowserFrame();
  
  DECLARE_EVENT_TABLE()

  void OnWindowClose (wxCloseEvent& event);

};


#endif

