#ifndef __WINDOWMANAGER_H_INCLUDED__
#define __WINDOWMANAGER_H_INCLUDED__

#include "csutil/array.h"
#include "csutil/ref.h"

#include "../common/csswmbase.h"
#include "csschildframe.h"
#include "cssmbframe.h"


struct iDocumentNode;
struct iCStudioCS;
class cssMapBrowserFrame;

class cssWindowManagerMultiframe : public cssWindowManagerBase
{
  csArray<cssChildFrame *> frames;
  cssMapBrowserFrame *mbframe;
  wxWindow *consolewnd;
  
  void WriteFrames(iDocumentNode *parent);
  void WriteSingleFrame(iDocumentNode *parent, cssChildFrame *cf);

  void GetFrames(iDocumentNode *root);
  void GetMapBrowser(iDocumentNode *root);
  void GetSingleFrame(iDocumentNode *framenode);
  
  virtual void AppendMenuItems();

  virtual void LoadSettings(iDocumentNode *parent);
  virtual void SaveSettings(iDocumentNode *parent);
  

  virtual void ShowPanels(bool show)
  { mbframe->Show(show); }
  virtual void CreateView(const char *classid);
  virtual void CloseViews();  
  
public:
  cssWindowManagerMultiframe(iBase* parent);
  virtual ~cssWindowManagerMultiframe();
  
  /// icssPlugin functions
  virtual const char *GetName()
    { return "cstudio.windowmanager.multiframe"; }
  
  /// icssWindowManager functions
  virtual void Activate(wxFrame* mainframe);
  virtual void Deactivate();
  
  cssChildFrame* CreateChildFrame(const char *classid);
  void Add(cssChildFrame *cf);
  void Remove(cssChildFrame *cf);
      
};

#endif
