/*
    Copyright (C) 2005 by Jan Lepper

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __CSSTABVIEWWND_H_INCLUDED__
#define __CSSTABVIEWWND_H_INCLUDED__


#include <wx/wx.h>

#include "csutil/refarr.h"
#include "csstabwindow.h"

struct iDocumentNode;
struct iCStudioCS;
struct icssCreateView;


class cssTabViewWnd : public cssTabWindow
{
  iCStudioCS *csi;
  csRefArray<icssCreateView> views;
  
public:

  cssTabViewWnd(wxWindow *parent, iCStudioCS *csi, wxPoint pos, wxSize size);
  ~cssTabViewWnd();
  
  void AddPage(const char *classid);  
  void ReplacePage(size_t idx, const char *classid);
  
  virtual void DeletePage(int idx);
  virtual void DeleteOtherPages(size_t idx);
  virtual void DeleteAllPages();

  bool Load(iDocumentNode *parent);
  bool Save(iDocumentNode *parent);
};


#endif
