/*
    Copyright (C) 2003 by Philipp Aumayr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __CSTUDIO_H_INCLUDED__
#define __CSTUDIO_H_INCLUDED__

#include "wx/wxprec.h"

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "cstudiocs.h"


class CStudioApp : public wxApp
{
public:
  /** Called at startup of App
  */
  virtual bool OnInit();

#if !wxCHECK_VERSION(2,5,2)
#ifdef WIN32
  virtual bool ProcessMessage(WXMSG *wxmsg);
#endif
#endif
 

  virtual int OnExit();

  void OnIdle(wxIdleEvent& event);

  /** Main Connection to CS
  */
  csRef<CStudioCS> csi;
  wxConfigBase* config;

  DECLARE_EVENT_TABLE()
};

DECLARE_APP(CStudioApp)


#endif // __CSTUDIO_H_INCLUDED__
